/*
 * This program counts the number of prime numbers up to first the number on the command line
 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int n = 1000;

#define LIST_SIZE	1000

int list_size;

// a list of prime numbers generated when the program starts

int primes_list[LIST_SIZE];

int is_prime (int p) {
	if (p == 0) return false;
	if (p == 1) return false;
	int lim = sqrt (p);

	// if the number is divisible by one of the known primes we stored, it is not prime

	int i;
	for (i=0; i < list_size && primes_list[i] <= lim; i++) {
		if (p % primes_list[i] == 0) return false;
	}

	// maybe we have to check numbers we didn't store, but most numbers don't arrive here

	for (i=list_size ? primes_list[list_size-1] : 2; i<=lim; i++) {
		if (p % i == 0) return false;
	}
	return true;
}

int pi (int m) {
	int number = 0;
	for (int i=0; i<m; i++) number += is_prime (i);
	return number;
}

void fill_list (void) {
	int p = 2;
	list_size = 0;
	do {
		if (is_prime (p)) primes_list[list_size++] = p;
		p++;
	} while (list_size < LIST_SIZE);
}

int main (int argc, char **argv) {
	if (argc == 2) {
		sscanf (argv[1], "%d", &n);
	}
	fill_list ();
	printf ("%d\n", pi (n));
	return 0;
}
